require "DualPistolWieldCommon"
DualPistolWield = DualPistolWield or {}



local hook = ISEquipWeaponAction.perform
function ISEquipWeaponAction:perform()
	if not self.twoHands and instanceof(self.item, "HandWeapon") and self.item:getSwingAnim() and self.item:getSwingAnim() == "Handgun" then
		if self.sound then
			self.character:getEmitter():stopSound(self.sound)
		end
		self.item:setJobDelta(0.0);

		if self:isAlreadyEquipped(self.item) then
			ISBaseTimedAction.perform(self);
			return
		end
		
		if self.character:isEquippedClothing(self.item) then
			self.character:removeWornItem(self.item)
			triggerEvent("OnClothingUpdated", self.character)
		end

		self.item:getContainer():setDrawDirty(true);
		forceDropHeavyItems(self.character)

		if self.fromHotbar then
			local hotbar = getPlayerHotbar(self.character:getPlayerNum());
			hotbar.chr:removeAttachedItem(self.item);
			self:setOverrideHandModels(self.item, nil)
		end
		if(self.primary) then			
			if self.character:getSecondaryHandItem() and self.character:getSecondaryHandItem():isRequiresEquippedBothHands() then
				self.character:setSecondaryHandItem(nil);
			end			
			if(self.character:getSecondaryHandItem() == self.item or self.character:getSecondaryHandItem() == self.character:getPrimaryHandItem()) then
				self.character:setSecondaryHandItem(nil);
			end
			if not self.character:getPrimaryHandItem() or self.character:getPrimaryHandItem() ~= self.item then
				self.character:setPrimaryHandItem(nil);
				self.character:setPrimaryHandItem(self.item);
			end
		else			
			if self.character:getPrimaryHandItem() and self.character:getPrimaryHandItem():isRequiresEquippedBothHands() then
				self.character:setPrimaryHandItem(nil);
			end
			if(self.character:getPrimaryHandItem() == self.item or self.character:getSecondaryHandItem() == self.character:getPrimaryHandItem()) then
				self.character:setPrimaryHandItem(nil);
			end		
			if not self.character:getSecondaryHandItem() or self.character:getSecondaryHandItem() ~= self.item then
				self.character:setSecondaryHandItem(nil);
				self.character:setSecondaryHandItem(self.item);
			end
		end
		getPlayerInventory(self.character:getPlayerNum()):refreshBackpacks();
		ISBaseTimedAction.perform(self);
	else
		hook(self)
	end
end
-----------------------               ---------------------------

local hook = ISReloadWeaponAction.BeginAutomaticReload
function ISReloadWeaponAction.BeginAutomaticReload(playerObj, gun)
	local pr = playerObj:getPrimaryHandItem() 
	local sr = playerObj:getSecondaryHandItem() 
	
	if  DualPistolWield.isDualWielding() and gun then 		
		if gun:getCurrentAmmoCount() < gun:getMaxAmmo() then	
			return hook(playerObj, gun)
		elseif gun:getCurrentAmmoCount() == gun:getMaxAmmo() then 	
			if isDebugEnabled() then print('Swapped'); end 
			return DualPistolWield.swapGuns()		
		elseif  gun:getCurrentAmmoCount() <= 0 or (gun:haveChamber() and not gun:isRoundChambered()) then
			--DualPistolWield.doSecondaryReload()
			return DualPistolWield.holsterPrimary()
		end

	else
		return hook(playerObj, gun) 
	end
end

-----------------------               ---------------------------
--[[ 
local function doSecondaryReload()
	local pl = getPlayer(); if not pl then return end 
	local pr = pl:getPrimaryHandItem() 
	local sr = pl:getSecondaryHandItem() 	
	local bool = false
	if DualPistolWield.isDualWielding() then bool = true end	
	if bool then
		ISTimedActionQueue.add(ISEquipWeaponAction:new(pl, sr, 25, true));
		ISReloadWeaponAction.BeginAutomaticReload(pl, sr)
		ISTimedActionQueue.add(ISEquipWeaponAction:new(pl, pr, 25, true));
		ISReloadWeaponAction.BeginAutomaticReload(pl, sr)
		luautils.equipItems(pl, pr, sr)
	end
end
 ]]
-----------------------               ---------------------------
-----------------------               ---------------------------

--[[ 

local hook = ISFirearmRadialMenu.onKeyReleased

function ISFirearmRadialMenu.onKeyReleased(key)
    if DualPistolWield.isDualWielding()  then
        local pl = getPlayer()
		local pr = pl:getPrimaryHandItem()
		local sr = pl:getSecondaryHandItem()
		luautils.equipItems(pl, sr, pr)
		ISReloadWeaponAction.BeginAutomaticReload(pl, pr)  

    else
        return hook(self, key)
    end
end

 ]]
 --[[ 
local hook = ISReloadWeaponAction.BeginAutomaticReload
ISReloadWeaponAction.BeginAutomaticReload = function(playerObj, gun)
	if DualPistolWield.isDualWielding()  then
		local pl = playerObj
		local pr = pl:getPrimaryHandItem()
		local sr = pl:getSecondaryHandItem()
		luautils.equipItems(pl, sr, pr)
		return hook(self, playerObj, gun)
	else
		return hook(self, playerObj, gun)
	end
end
 ]]
--[[ 
local pl = getPlayer()
local wpn1 = pl:getPrimaryHandItem()
local wpn2 = pl:getSecondaryHandItem()

ISReloadWeaponAction.BeginAutomaticReload(pl, wpn2)

ISReloadWeaponAction.BeginAutomaticReload(pl, pr)

ISTimedActionQueue.add(ISEquipWeaponAction:new(pl, wpn2, 25, true))

local pl = getPlayer()
local wpn1 = pl:getPrimaryHandItem()
local wpn2 = pl:getSecondaryHandItem()
ISReloadWeaponAction.BeginAutomaticReload(pl, wpn1)
ISTimedActionQueue.queueActions(pl, ISEquipWeaponAction:new(pl, wpn2, 25, true))
ISTimedActionQueue.queueActions(pl, ISReloadWeaponAction:new(pl, wpn2))
ISTimedActionQueue.queueActions(pl, ISEquipWeaponAction:new(pl, wpn1, 25, true))
luautils.equipItems(pl, wpn1, wpn2)
 ]]
--[[ 

ISTimedActionQueue.add(ISEquipWeaponAction:new(getPlayer(), sr, 5, true));
ISReloadWeaponAction.BeginAutomaticReload(getPlayer(), sr)
ISTimedActionQueue.clear(getPlayer())
 ]]