require "DualPistolWieldCommon"
DualPistolWield = DualPistolWield or {}

local function  isCanGetActual(name)
	local player = getPlayer() 
	if not player then return end	
	local inv = player:getInventory() 
	local wpn = nil
	if type(name) == 'string' then
		wpn = inv:FindAndReturn(name)
	else
		wpn = name
	end	
	if not wpn then return false end
	return true
end

local function wieldActual(name)	
	local player = getPlayer() 
	if not player then return nil end	
	local inv = player:getInventory() 
	local wpn = nil
	if type(name) == 'string' then
		wpn = inv:FindAndReturn(name)
	else
		wpn = name
	end	
	return wpn or nil
end
--[[ 

function  DualPistolWieldContext(player, context, items)
	for i, item in ipairs(items) do		
		if type(item) == "table" then
			local name = item.items[1]:getFullType()
			if name and isCanGetActual(name) then
				local wpn = wieldActual(name)
				if wpn and DualPistolWield.isPistol(wpn)  then				
					local pl = getPlayer()
					local pr = pl:getPrimaryHandItem() 
					local sr = pl:getSecondaryHandItem() 
					
					if pr and DualPistolWield.isPistol(pr)	 then		
						context:removeOptionByName(getText("ContextMenu_Equip_Secondary")) 		
						context:insertOptionAfter('Favorite', getText("ContextMenu_Equip_Secondary")..' Dual', wpn, function()			
							DualPistolWield.equip(pl, nil, wpn)
						end , player );									
					end
					
					if sr and DualPistolWield.isPistol(sr)  then	
						context:removeOptionByName(getText("ContextMenu_Equip_Primary"))    
						context:insertOptionAfter('Favorite', getText("ContextMenu_Equip_Primary")..' Dual', wpn, function()							
							DualPistolWield.equip(pl, wpn, nil)
						end , player );		
					end
				end
			end
		end
	end
end
Events.OnFillInventoryObjectContextMenu.Add(DualPistolWieldContext);



ISInventoryPaneContextMenu.doEquipOption = function(context, playerObj, isWeapon, items, player)
    -- check if hands if not heavy damaged
    if (not playerObj:isPrimaryHandItem(isWeapon) or (playerObj:isPrimaryHandItem(isWeapon) and playerObj:isSecondaryHandItem(isWeapon))) and not getSpecificPlayer(player):getBodyDamage():getBodyPart(BodyPartType.Hand_R):isDeepWounded() and (getSpecificPlayer(player):getBodyDamage():getBodyPart(BodyPartType.Hand_R):getFractureTime() == 0 or getSpecificPlayer(player):getBodyDamage():getBodyPart(BodyPartType.Hand_R):getSplintFactor() > 0) then
        -- forbid reequipping skinned items to avoid multiple problems for now
        local add = true;
        if playerObj:getSecondaryHandItem() == isWeapon and isWeapon:getScriptItem():getReplaceWhenUnequip() then
            add = false;
        end
        if add then
            context:addOption(getText("ContextMenu_Equip_Primary"), items, ISInventoryPaneContextMenu.OnPrimaryWeapon, player);
        end
    end
    if (not playerObj:isSecondaryHandItem(isWeapon) or (playerObj:isPrimaryHandItem(isWeapon) and playerObj:isSecondaryHandItem(isWeapon))) and not getSpecificPlayer(player):getBodyDamage():getBodyPart(BodyPartType.Hand_L):isDeepWounded() and (getSpecificPlayer(player):getBodyDamage():getBodyPart(BodyPartType.Hand_L):getFractureTime() == 0 or getSpecificPlayer(player):getBodyDamage():getBodyPart(BodyPartType.Hand_L):getSplintFactor() > 0) then
        -- forbid reequipping skinned items to avoid multiple problems for now
        local add = true;
        if playerObj:getPrimaryHandItem() == isWeapon and isWeapon:getScriptItem():getReplaceWhenUnequip() then
            add = false;
        end
        if add then
            context:addOption(getText("ContextMenu_Equip_Secondary"), items, ISInventoryPaneContextMenu.OnSecondWeapon, player);
        end
    end
end
 ]]